#!/usr/bin/perl
#
#   Tapatap version 0.6 (First public release)
#
#   V Vinay (vinay@csa.iisc.ernet.in)
#
#   You require perl/Tk to run this program. 
#   You should see a 3x3 grid, there are indexed in row major order.
#        
#        0 1 2
#        3 4 5
#        6 7 8
#
# Click the first button to form letters ... 
# Example: clicking on boxes 6 1 8 should output an "a"  etc
# Many characters have been mapped to the grid, look at the end of this
# file for the tap sequences.
#
# See the file LICENSE and COPYING for distribution of Tapatap


use Tk;
use libvirtkeys;

my $mode = 'letter';
my $prev_sent = 'Xspace';
my $prev_sft_ref = 0;
my $prev_ctl_ref = 0;
my $prev_alt_ref = 0;
my $substr="";

while (<DATA>) {
	chomp;
	my ($scan,$letter)=split;
	if ($letter=~/SPACE/) {$letter=" "}
	if ($letter=~/NEWLINE/) {$letter="\n"}
	if ($letter=~/TAB/) {$letter="\t"}
	if ($letter=~/BACK/) {$letter="\b \b"}
	$Key{$scan}=$letter;
}

$xoff=$yoff=15;
$x0=$xoff; $x1=$x0+30; $x2=$x1+30; $x3=$x2+30;
$y0=$yoff; $y1=$y0+30; $y2=$y1+30; $y3=$y2+30;

$nx0=$xoff; $nx1=$nx0+30; $nx2=$nx1+30; $nx3=$nx2+30;
$ny0=$yoff; $ny1=$ny0+25; $ny2=$ny1+25; $ny3=$ny2+25;$ny4=$ny3+25;

$$ctl_ref=0;
$$alt_ref=0;
$$sft_ref=0;
$$hld_ref=0;

$mw=MainWindow->new;
libvirtkeys::initsendkey();
$mw->focusmodel("active");

$mode_but=$mw->Button(-text=>'123',-width=>4,
    -command=> sub {
        if($mode=~/letter/) {
            $mode = 'number'; $mode_but->configure(-text=>'abc');
            $prevx=-1; $prevy=-1; $substr="";
            $canv->delete('stroke'); $sft_btn->configure(-state=>'disabled');
            letter_state('hidden'); number_state('normal');
        }
        else {
            $mode = 'letter'; $mode_but->configure(-text=>'123');
            $prevx=-1; $prevy=-1; $substr="";
            $canv->delete('stroke'); $sft_btn->configure(-state=>'normal');
            number_state('hidden'); letter_state('normal');
        }
    })->pack(-pady=>'2');

$canv=$mw->Canvas(-height=>120, -width=>120)->pack;

$canv->create('line', $x0,$y0,$x3,$y0, -tag=> 'lb0' );
$canv->create('line', $x0,$y1,$x3,$y1, -tag=> 'lb1' );
$canv->create('line', $x0,$y2,$x3,$y2, -tag=> 'lb2' );
$canv->create('line', $x0,$y3,$x3,$y3, -tag=> 'lb3' );
$canv->create('line', $x0,$y0,$x0,$y3, -tag=> 'lb4' );
$canv->create('line', $x1,$y0,$x1,$y3, -tag=> 'lb5' );
$canv->create('line', $x2,$y0,$x2,$y3, -tag=> 'lb6' );
$canv->create('line', $x3,$y0,$x3,$y3, -tag=> 'lb7' );

$canv->create('line', $nx0,$ny0,$nx3,$ny0, -tag=> 'nb0' );
$canv->create('line', $nx0,$ny1,$nx3,$ny1, -tag=> 'nb1' );
$canv->create('line', $nx0,$ny2,$nx3,$ny2, -tag=> 'nb2' );
$canv->create('line', $nx0,$ny3,$nx3,$ny3, -tag=> 'nb3' );
$canv->create('line', $nx0,$ny4,$nx3,$ny4, -tag=> 'nb4' );
$canv->create('line', $nx0,$ny0,$nx0,$ny4, -tag=> 'nb5' );
$canv->create('line', $nx1,$ny0,$nx1,$ny4, -tag=> 'nb6' );
$canv->create('line', $nx2,$ny0,$nx2,$ny4, -tag=> 'nb7' );
$canv->create('line', $nx3,$ny0,$nx3,$ny4, -tag=> 'nb8' );


$font240='-*-times-medium-r-normal--*-240-*-*-*-*-*-';
$font120='-*-times-medium-r-normal--*-120-*-*-*-*-*-';
$canv->create('text', $nx0+15, $ny0+15,-text=>'1',-font=>$font240,-tag=>'t1');
$canv->create('text', $nx1+15, $ny0+15,-text=>'2',-font=>$font240,-tag=>'t2');
$canv->create('text', $nx2+15, $ny0+15,-text=>'3',-font=>$font240,-tag=>'t3');
$canv->create('text', $nx0+15, $ny1+15,-text=>'4',-font=>$font240,-tag=>'t4');
$canv->create('text', $nx1+15, $ny1+15,-text=>'5',-font=>$font240,-tag=>'t5');
$canv->create('text', $nx2+15, $ny1+15,-text=>'6',-font=>$font240,-tag=>'t6');
$canv->create('text', $nx0+15, $ny2+15,-text=>'7',-font=>$font240,-tag=>'t7');
$canv->create('text', $nx1+15, $ny2+15,-text=>'8',-font=>$font240,-tag=>'t8');
$canv->create('text', $nx2+15, $ny2+15,-text=>'9',-font=>$font240,-tag=>'t9');
$canv->create('text', $nx0+13, $ny3+13,-text=>'BS',-font=>$font120,-tag=>'tfn');
$canv->create('text', $nx1+15, $ny3+15,-text=>'0',-font=>$font240,-tag=>'t0');
$canv->create('text', $nx2+14, $ny3+13,-text=>'Ret',-font=>$font120,-tag=>'tlet');

letter_state('normal');
number_state('hidden');

$meta_frame = $mw->Frame(-width=>120, -height=>50)->pack(-side=>'top');

$ctl_btn=$meta_frame->Checkbutton(-text => 'C', 
        -variable=> $ctl_ref,
        -command => \&hld_reset )->pack(-side=>'left');

$alt_btn=$meta_frame->Checkbutton(-text => 'A', 
        -variable=> $alt_ref,
        -command => \&hld_reset )->pack(-side=>'left');

$sft_btn=$meta_frame->Checkbutton(-text => 'S', 
        -variable=> $sft_ref,
        -command => \&hld_reset )->pack(-side=>'left');

$hld_btn=$meta_frame->Checkbutton(-text => 'L', 
        -variable=> $hld_ref,
        -command => \&hld_toggle )->pack(-side=>'left');

$substr="";$prevx=-1;$prevy=-1;
$canv->Tk::bind('<1>'=>\&stroke);
MainLoop;

sub hld_reset {
    $$hld_ref = 0;
}

sub hld_toggle {
}

sub stroke{
	my $e=$canv->XEvent;
	my ($x,$y)=($e->x, $e->y);

    if($mode=~/(number)/){
        if ($x<$nx0||$y<$ny0||$nx3<$x||$ny4<$y) {
            $mode='number';
            return;
        }
        my $xsh=$x-$xoff; my $ysh=$y-$yoff;
        my $xcoord=int($xsh/30);
        my $ycoord=int($ysh/25);
        my $box=$xcoord + 3*$ycoord;

        if($box < 9){
            $box++;
        }
        elsif ($box == 9){
            $box="BackSpace";
        }
        elsif ($box == 10){
            $box=0;
        }
        elsif ($box == 11){
            $box="Return";
        }
        $substr="X".$box;
        libvirtkeys::sendkey($substr,$$sft_ref,$$ctl_ref,$$alt_ref,0);
        return;
    }
    
	if ($x<$x0||$y<$y0||$x3<$x||$y3<$y) {
		$canv->delete('stroke');
		$substr="";$prevx=0;$prevy=0;
		return
	}
	if ($prevx>0) {
		$canv->create('line',$prevx,$prevy,$x,$y, -tag=>'stroke');
	}elsif ($prevx==0) {
		$canv->delete('stroke');
	}
	$canv->create('rect',$x-2,$y-2,$x+2,$y+2,-tag=>'stroke');
	my $xsh=$x-$xoff; my $ysh=$y-$yoff;
	my $xcoord=int($xsh/30);
	my $ycoord=int($ysh/30);
	my $box=$xcoord+3*$ycoord;
	$substr.=$box;

	if (exists $Key{$substr}) {
		#print "Sending $Key{$substr}";
		#print "Ctrl=$$ctl_ref,Alt=$$alt_ref,Shift=$$sft_ref";

        if($Key{$substr}=~/repeat/)
        {
		    $substr="";$prevx=0;$prevy=0;
            $canv->itemconfigure('stroke', -width=>2);
            libvirtkeys::sendkey($prev_sent, $prev_sft_ref, $prev_ctl_ref, 
                    $prev_alt_ref,0);
            return;
        }

        libvirtkeys::sendkey($Key{$substr},$$sft_ref,$$ctl_ref,$$alt_ref,0);
        $prev_sent = $Key{$substr};
        $prev_sft_ref = $$sft_ref;
        $prev_ctl_ref = $$ctl_ref;
        $prev_alt_ref = $$alt_ref;
		$substr="";$prevx=0;$prevy=0;
        if($$hld_ref == 0)
        {
            $$sft_ref = 0;
            $$alt_ref = 0;
            $$ctl_ref = 0;
        }
		$canv->itemconfigure('stroke', -width=>2);
		return;
	}
	$prevx=$x;$prevy=$y;
}

sub letter_state {
    my $state = shift;

    $canv->itemconfigure('lb0', state => $state);
    $canv->itemconfigure('lb1', state => $state);
    $canv->itemconfigure('lb2', state => $state);
    $canv->itemconfigure('lb3', state => $state);
    $canv->itemconfigure('lb4', state => $state);
    $canv->itemconfigure('lb5', state => $state);
    $canv->itemconfigure('lb6', state => $state);
    $canv->itemconfigure('lb7', state => $state);
}

sub number_state {
    my $state = shift;

    $canv->itemconfigure('t0', state => $state);
    $canv->itemconfigure('t1', state => $state);
    $canv->itemconfigure('t2', state => $state);
    $canv->itemconfigure('t3', state => $state);
    $canv->itemconfigure('t4', state => $state);
    $canv->itemconfigure('t5', state => $state);
    $canv->itemconfigure('t6', state => $state);
    $canv->itemconfigure('t7', state => $state);
    $canv->itemconfigure('t8', state => $state);
    $canv->itemconfigure('t9', state => $state);
    $canv->itemconfigure('tlet', state => $state);
    $canv->itemconfigure('tfn', state => $state);

    $canv->itemconfigure('nb0', state => $state);
    $canv->itemconfigure('nb1', state => $state);
    $canv->itemconfigure('nb2', state => $state);
    $canv->itemconfigure('nb3', state => $state);
    $canv->itemconfigure('nb4', state => $state);
    $canv->itemconfigure('nb5', state => $state);
    $canv->itemconfigure('nb6', state => $state);
    $canv->itemconfigure('nb7', state => $state);
    $canv->itemconfigure('nb8', state => $state);
}

__DATA__
618 Xa
023 Xb
238 Xc
056 Xd
137 Xe
217 Xf
237 Xg
35 Xh
17 Xi
284 Xj
260 Xk
067 Xl
607 Xm
608 Xn
262 Xo
6023 Xp
30148 Xq
60248 Xr
208 Xs
017 Xt
068 Xu
072 Xv
061 Xw
082 Xx
042 Xy
026 Xz
37 Xquoteleft
3042 Sasciitilde
036 Sexclam
568 Sat
012 Snumbersign
205 Sdollar
002 Spercent
315 Sasciicircum
168 Sampersand
642 Sasterisk
134 Sparenleft
154 Sparenright
12 Xminus
78 Sunderscore
4578 Xequal
34517 Splus
18 Xbackslash
258 Sbar
10 XBackSpace
68 XTab
037 Sbracketleft
257 Sbracketright
467 Sbraceleft
487 Sbraceright
57 XReturn
446 Xsemicolon
58 Scolon
0314 Squotedbl
27 Xslash
77 Xcomma
248 Sless
55 Xperiod
046 Sgreater
016 Squestion
67 Xspace
882 XUp
668 XRight
886 XLeft
228 XDown
11 !repeat
